/**
http://homes.cs.washington.edu/~djg/teachingMaterials/spac/sophomoricParallelismAndConcurrency.pdf

*/
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveAction;

class SumArray extends RecursiveAction
{
   static int SEQUENTIAL_THRESHOLD = 1000;
   int lo;
   int hi;
   int[] arr;
   int ans = 0;

   SumArray(int[] a, int l, int h)
   {
      lo=l; hi=h; arr=a;
   }

   protected void compute()
   {
      if(hi - lo <= SEQUENTIAL_THRESHOLD)
      {
         for(int i=lo; i < hi; ++i)
            ans += arr[i];
      }
      else
      {
         SumArray left  = new SumArray(arr,lo,(hi+lo)/2);
         SumArray right = new SumArray(arr,(hi+lo)/2,hi);
         left.fork();
         right.compute();
         left.join();
         ans = left.ans + right.ans;
      }
   }
}


class Main
{
   static final ForkJoinPool fjPool = new ForkJoinPool();

   static int sumArray(int[] array)
   {
      SumArray t = new SumArray(array,0,array.length);
      fjPool.invoke(t);
      return t.ans;
   }
}


public class Section_3_4a
{
   public static void main(String[] args)
   {
   }
}