/**
http://homes.cs.washington.edu/~djg/teachingMaterials/spac/sophomoricParallelismAndConcurrency.pdf

*/
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

class SumArray extends RecursiveTask<Integer>
{
   static int SEQUENTIAL_THRESHOLD = 1000;
   int lo;
   int hi;
   int[] arr;


   SumArray(int[] a, int l, int h)
   {
      lo=l; hi=h; arr=a;
   }

   public Integer compute()
   {
      if(hi - lo <= SEQUENTIAL_THRESHOLD)
      {
         int ans = 0;
         for(int i=lo; i < hi; ++i)
            ans += arr[i];
         return ans;
      }
      else
      {
         SumArray left  = new SumArray(arr,lo,(hi+lo)/2);
         SumArray right = new SumArray(arr,(hi+lo)/2,hi);
         left.fork();
         int rightAns = right.compute();
         int  leftAns = left.join();
         return leftAns + rightAns;
      }
   }
}


class Main
{
   static final ForkJoinPool fjPool = new ForkJoinPool();

   static int sumArray(int[] array)
   {
      return fjPool.invoke(new SumArray(array,0,array.length));
   }
}


public class Section_3_4b
{
   public static void main(String[] args)
   {
   }
}