import java.util.concurrent.RecursiveAction;

public class ProblemWithFJ<T> extends RecursiveAction
{
    private final int threshold;
    private final Problem<T> problem;
    public T result;


    public ProblemWithFJ(Problem<T> problem, int threshold)
    {
        this.problem = problem;
        this.threshold = threshold;
    }


    @Override
    protected void compute()
    {
        if (problem.getSize() < threshold)
            result = problem.solveSequentially();
        else
        {
            ProblemWithFJ<T> left =  new ProblemWithFJ(problem.leftSubproblem(), threshold);
            ProblemWithFJ<T> right = new ProblemWithFJ(problem.rightSubproblem(), threshold);
            left.fork();      // asynchronous
            right.compute();  //  synchronous
            left.join();      //  synchronous
            result = problem.combine(left.result, right.result);
        }
    }
}