/**

*/
import java.util.concurrent.ForkJoinPool;

public class Fib_Java7
{
   public static void main(String[] args)
   {
      if (0 == args.length)
      {
         System.err.println("Usage: java Fib_Java7 <size> <threshold>");
         System.exit(-1);
      }
      int n = Integer.parseInt(args[0]);
      int threshold = Integer.parseInt(args[1]);

      FibProblem problem = new FibProblem(n);

      long startTime, stopTime;

      // Run the single-threaded sequential version.
      startTime = System.currentTimeMillis();
      long result = problem.solveSequentially(); // synchronous function call
      stopTime = System.currentTimeMillis();
      System.out.println("Sequential solution: " + result);
      System.out.println("Sequential solution time: " + (stopTime - startTime));

      // Run the fork-join version.
      ForkJoinPool fjPool = new ForkJoinPool();
      SolveProblemWithFJ<Long> fj = new SolveProblemWithFJ<Long>(problem, threshold);
      startTime = System.currentTimeMillis();
      fjPool.invoke(fj);        //  synchronous task
      stopTime = System.currentTimeMillis();
      System.out.println(" Fork-join soultion: " + fj.result);
      System.out.println(" Fork-join solution time: " + (stopTime - startTime));
      System.out.println("forkJoinPool: " + fjPool.toString());
   }
}