/**

*/

class MaxProblem implements Problem<Long>
{
   private final long[] numbers;
   private final int start;
   private final int end;
   public  final int size;

   public MaxProblem(long[] numbers, int start, int end)
   {
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
   }

   public int getSize()
   {
      return size;
   }

   public Long solveSequentially()
   {
      long max = Long.MIN_VALUE;
      for (int i = start; i <= end; i++)
      {
         long n = numbers[i];
         if (n > max) max = n;
      }
      return max;
   }

   public Problem<Long> leftSubproblem()
   {
      return new MaxProblem(numbers, start, start + size/2 - 1);
   }

   public Problem<Long> rightSubproblem()
   {
      return new MaxProblem(numbers, start + size/2, end);
   }

   public Long combine(Long left, Long right)
   {
      return Math.max( left, right );
   }
}
