/**

*/

class SearchProblem implements Problem<Integer>
{
   private final int target;
   private final int[] numbers;
   private final int start;
   private final int end;
   public  final int size;

   public SearchProblem(int target, int[] numbers, int start, int end)
   {
      this.target = target;
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
   }


   public int getSize()
   {
      return size;
   }

   public Integer solveSequentially()
   {
      int i = start;
      for (; (i <= end) && (numbers[i] != target); i++){}
      return (i == end+1) ? -1 : i;
   }

   public Problem<Integer> leftSubproblem()
   {
      return new SearchProblem(target, numbers, start, start + size/2 - 1);
   }

   public Problem<Integer> rightSubproblem()
   {
      return new SearchProblem(target, numbers, start + size/2, end);
   }

   public Integer combine(Integer left, Integer right)
   {
      return (0 <= left) ? left : right;
   }
}