/**
   From
      http://www.ibm.com/developerworks/java/library/j-jtp11137/index.html
*/
import java.util.concurrent.ForkJoinPool;
import java.util.Random;

public class Max_Java7
{
   public static void main(String[] args)
   {
      if (0 == args.length)
      {
         System.err.println("Usage: java Max_Java7 <size> <threshold>");
         System.exit(-1);
      }
      int n = Integer.parseInt(args[0]);
      int threshold = Integer.parseInt(args[1]);

      long numbers[] = new long[n];

      Random generator = new Random();
      for (int i = 0; i < numbers.length; i++)
         numbers[i] = generator.nextLong();

      MaxProblem problem = new MaxProblem(numbers, 0, numbers.length - 1);

      long startTime;
      long stopTime;

      // Run the single-threaded sequential version.
      startTime = System.currentTimeMillis();
      problem.solveSequentially(); // synchronous function call
      stopTime = System.currentTimeMillis();
      System.out.println("Sequential solution: " + problem.result);
      System.out.println("Sequential solution time: " + (stopTime - startTime));

      // Run the fork-join version.
      ForkJoinPool fjPool = new ForkJoinPool();
      SolveProblemWithFJ fj = new SolveProblemWithFJ(problem, threshold);
      startTime = System.currentTimeMillis();
      fjPool.invoke(fj);        //  synchronous task
      stopTime = System.currentTimeMillis();
      System.out.println(" Fork-join soultion: " + problem.result);
      System.out.println(" Fork-join solution time: " + (stopTime - startTime));
      System.out.println("forkJoinPool: " + fjPool.toString());
   }
}