/**

*/

class MaxProblem implements Problem
{
   private final long[] numbers;
   private final int start;
   private final int end;
   private final int size;
   public long result;

   public MaxProblem(long[] numbers, int start, int end)
   {
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
   }

   public int getSize()
   {
      return this.size;
   }

   public void solveSequentially()
   {
      long max = Long.MIN_VALUE;
      for (int i = start; i <= end; i++)
      {
         long n = numbers[i];
         if (n > max) max = n;
      }
      result = max;
   }

   public Problem leftSubproblem()
   {
      return new MaxProblem(numbers, start, start + size/2 - 1);
   }

   public Problem rightSubproblem()
   {
      return new MaxProblem(numbers, start + size/2, end);
   }

   public <T extends Problem> void combine(T left, T right)
   {
      this.result = Math.max( ((MaxProblem)left).result, ((MaxProblem)right).result );
   }
}
