public interface Problem
{
   int getSize();
   void solveSequentially();
   Problem leftSubproblem();
   Problem rightSubproblem();
   <T extends Problem> void combine(T left, T right);
}
/*
   This combine() method is contracted to accept ANY type T
   that extends Problem.

   The error in the following implementation is that it
   accepts ONLY the type FibProblem.

   public void combine(FibProblem left, FibProblem right)
   {
      this.result = left.result + right.result;
   }


   NOTE: This declaration of combine() is better than

   void combine(Problem left, Problem right);

   because that declaration does not specify that left and right
   must have the same type!
*/
