import java.util.concurrent.RecursiveAction;

public class SolveProblemWithFJ extends RecursiveAction
{
    private final int threshold;
    private final Problem problem;

    public SolveProblemWithFJ(Problem problem, int threshold)
    {
        this.problem = problem;
        this.threshold = threshold;
    }

    @Override
    protected void compute()
    {
        if (problem.getSize() < threshold)
            problem.solveSequentially();
        else
        {
            SolveProblemWithFJ left  = new SolveProblemWithFJ(problem.leftSubproblem(),  threshold);
            SolveProblemWithFJ right = new SolveProblemWithFJ(problem.rightSubproblem(), threshold);
            left.fork();      // asynchronous
            right.compute();  //  synchronous
            left.join();      //  synchronous
            problem.combine(left.problem, right.problem);
        }
    }
}