/**

*/

class SearchProblem implements Problem<SearchProblem>
{
   private final int target;
   private final int[] numbers;
   private final int start;
   private final int end;
   public  final int size;
   public int result;

   public SearchProblem(int target, int[] numbers, int start, int end)
   {
      this.target = target;
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
   }

   public int getSize()
   {
      return this.size;
   }

   public void solveSequentially()
   {
      int i = start;
      for (; (i <= end) && (numbers[i] != target); i++){}
      this.result = (i == end+1) ? -1 : i;
   }

   public SearchProblem leftSubproblem()
   {
      return new SearchProblem(target, numbers, start, start + size/2 - 1);
   }

   public SearchProblem rightSubproblem()
   {
      return new SearchProblem(target, numbers, start + size/2, end);
   }

   public void combine(SearchProblem left, SearchProblem right)
   {
      this.result = (0 <= left.result) ? left.result : right.result;
   }
}