/**

*/
import java.util.Arrays;

class SortProblem implements Problem<SortProblem>
{
   private final int[] numbers;
   private final int start;
   private final int end;
   public  final int size;
   public  final int[] result;

   public SortProblem(int[] numbers, int start, int end)
   {
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
      this.result = new int[this.size];
   }

   public int getSize()
   {
      return size;
   }

   public void solveSequentially()
   {
      System.arraycopy(this.numbers, this.start, this.result, 0, this.size);
      Arrays.sort(this.result, 0, this.size);
   }

   public SortProblem leftSubproblem()
   {
      return new SortProblem(numbers, start, start + size/2 - 1);
   }

   public SortProblem rightSubproblem()
   {
      return new SortProblem(numbers, start + size/2, end);
   }

   public void combine(SortProblem left, SortProblem right)
   {
      int i=0, leftPos=0, rightPos=0, leftSize = left.size, rightSize = right.size;

      while (leftPos < leftSize && rightPos < rightSize)
         result[i++] = (left.result[leftPos] <= right.result[rightPos])
                          ? left.result[leftPos++] : right.result[rightPos++];

      while (leftPos < leftSize)
         result[i++] = left.result[leftPos++];

      while (rightPos < rightSize)
         result[i++] = right.result[rightPos++];
   }
}