/**

*/

class SearchProblem extends Problem
{
   private final int target;
   private final int[] numbers;
   private final int start;
   private final int end;
   public  final int size;
   public int result;

   public SearchProblem(int target, int[] numbers, int start, int end, int threshold)
   {
      super(threshold);
      this.target = target;
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
   }

   public int getSize()
   {
      return this.size;
   }

   public void solveSequentially()
   {
      int i = start;
      for (; (i <= end) && (numbers[i] != target); i++){}
      this.result = (i == end+1) ? -1 : i;
   }

   public Problem leftSubproblem()
   {
      return new SearchProblem(target, numbers, start, start + size/2 - 1, threshold);
   }

   public Problem rightSubproblem()
   {
      return new SearchProblem(target, numbers, start + size/2, end, threshold);
   }

   public void combine(Problem left, Problem right)
   {
      int leftResult  = ((SearchProblem)left).result;
      int rightResult = ((SearchProblem)right).result;
      this.result = (0 <= leftResult) ? leftResult : rightResult;
   }
}