/**

*/
import java.util.Arrays;

class SortProblem extends Problem
{
   private final int[] numbers;
   private final int start;
   private final int end;
   public  final int size;
   public  final int[] result;

   public SortProblem(int[] numbers, int start, int end, int threshold)
   {
      super(threshold);
      this.numbers = numbers;
      this.start = start;
      this.end = end;
      this.size = (end - start) + 1;
      this.result = new int[this.size];
   }

   public int getSize()
   {
      return size;
   }

   public void solveSequentially()
   {
      System.arraycopy(this.numbers, this.start, this.result, 0, this.size);
      Arrays.sort(this.result, 0, this.size);
   }

   public Problem leftSubproblem()
   {
      return new SortProblem(numbers, start, start + size/2 - 1, threshold);
   }

   public Problem rightSubproblem()
   {
      return new SortProblem(numbers, start + size/2, end, threshold);
   }

   public void combine(Problem left, Problem right)
   {
      int i=0, leftPos=0, rightPos=0;
      int leftSize  = ((SortProblem)left).size;
      int rightSize = ((SortProblem)right).size;

      while (leftPos < leftSize && rightPos < rightSize)
         result[i++] = (((SortProblem)left).result[leftPos] <= ((SortProblem)right).result[rightPos])
                          ? ((SortProblem)left).result[leftPos++] : ((SortProblem)right).result[rightPos++];

      while (leftPos < leftSize)
         result[i++] = ((SortProblem)left).result[leftPos++];

      while (rightPos < rightSize)
         result[i++] = ((SortProblem)right).result[rightPos++];
   }
}