/**
   From
      http://www.ibm.com/developerworks/java/library/j-jtp11137/index.html
*/
import java.util.concurrent.ForkJoinPool;
import java.util.Random;

public class Sort_Java7
{
   public static final int PROBLEM_SIZE = 10_000_000;
   public static long numbers[] = new long[PROBLEM_SIZE];

   public static void main(String[] args)
   {
      if (0 == args.length)
      {
         System.err.println("Usage: java Sort_Java7 <size> <threshold>");
         System.exit(-1);
      }
      int size = Integer.parseInt(args[0]);
      int threshold = Integer.parseInt(args[1]);

      int numbers[] = new int[size];

      Random generator = new Random();
      for (int i = 0; i < numbers.length; i++)
         numbers[i] = generator.nextInt();

      SortProblem problem = new SortProblem(numbers, 0, numbers.length - 1, threshold);

      long startTime;
      long stopTime;

      // Run the single-threaded sequential version.
      startTime = System.currentTimeMillis();
      problem.solveSequentially(); // synchronous function call
      stopTime = System.currentTimeMillis();
      System.out.println("Sequential solution time: " + (stopTime - startTime));
      // print the first couple of hundred numbers in six COLUMNS.
      for (int i = 0; i < 30; i++)
      {
         for (int j = 0; j < 6; j++)
         {
            System.out.printf("%d ", problem.result[i+(30*j)]);
         }
         System.out.printf("\n");
      }

      // Run the fork-join version.
      ForkJoinPool fjPool = new ForkJoinPool();
      startTime = System.currentTimeMillis();
      fjPool.invoke(problem);        //  synchronous task
      stopTime = System.currentTimeMillis();
      System.out.println(" Fork-join solution time: " + (stopTime - startTime));
      System.out.println("forkJoinPool: " + fjPool.toString());
      // print the first couple of hundred numbers in six COLUMNS.
      for (int i = 0; i < 30; i++)
      {
         for (int j = 0; j < 6; j++)
         {
            System.out.printf("%d ", problem.result[i+(30*j)]);
         }
         System.out.printf("\n");
      }
   }
}